<div id="functions">

</div>
 <script type="module">
import { Tree } from "/js/Tree/Tree.js";
import { Module } from "/js/client.js";




//=========================================================
export class FunctionModule extends Module {
//=========================================================

    //-----------------------------------------------------
    constructor(client,id) {
    //-----------------------------------------------------
        super(client,null);
        this.id = id;


    }
    //-----------------------------------------------------
    update() {
    //-----------------------------------------------------
       var data=this.onRequest();
       console.log("send",data);
       this.parent.ask_json(data,this.onDo.bind(this));
        return false;
    }
    //-----------------------------------------------------
    onRequest() {
    //-----------------------------------------------------

        var data = {};
        return data;
    }
    //-----------------------------------------------------
    onDo(data) {
    //-----------------------------------------------------
       //console.log("result",data.response);
   var string="";
    for (const element of Object.keys(data.response)) {

          var elt=data.response[element];
          //console.log(elt);
           string += this.show_class(element,elt);
          if(elt.functions){
          console.log(elt.functions);
            for (const k of Object.keys(elt.functions)) {
            string += this.show_function(k,elt.functions[k]);
            }
          }

    }
    $("#"+this.id).html(string);
    }
    //-----------------------------------------------------
    show_class(name,data) {
    //-----------------------------------------------------
   var string="";
          string += `<h2>${name}</h2>`;
          if(data.doc){
                   string += ` <pre>${data.doc}</pre>`;
          }
          if(data.fields){
          console.log(data.fields);
          string+="<table>";
            for (const k of Object.keys(data.fields)) {
                var elt=data.fields[k];
                string += `<tr><td style="width:15%">${k}</td><td style="width:15%">${elt.cls}</td><td style="width:15%">${elt.record}</td><td style="width:55%">${elt.doc}</td></tr>`;
            }
        string += `</table>`;
        }
        return string;
    }
    //-----------------------------------------------------
    show_function(name,data) {
    //-----------------------------------------------------
   var string="";
          string += `<form><h3>${name}</h3>`;
          if(data.doc){
                   string += ` <pre>${data.doc}</pre>`;
          }


          if(data.attrs){
          console.log(data.attrs);
            for (const k of Object.keys(data.attrs)) {
                var attr=data.attrs;
               string += `   <label for="${k}">${k}:</label>
  <input type="text" id="${k}" name="${k}"><br>`;
            }
        }
           string += `     <input type="submit" value="execute"> </form>`;
        return string;
    }
    //-----------------------------------------------------

}
//=========================================================
var tree=new FunctionModule(document.app,"functions");
tree.update();
</script> 
